import es
import cfglib, popuplib, playerlib

config = cfglib.AddonCFG(es.getAddonPath('ggn') + '/config.cfg')

config.text('*********************************')
config.text('* Guns\'n\'Grenades Configuration *')
config.text('*********************************')
config.text('\n')
config.text('* Weapon Configuration *')
gun = config.cvar('ggn_gun', 'glock', 'Set the weapon you want (withOUT the weapon_ prefix!)')
nade = config.cvar('ggn_nade', 'hegrenade', 'Set the grenade you want (withOUT the weapon_ prefix!) options: hegrenade, flashbang, smokegrenade')
config.text('\n')
config.text('* Price Configuration *')
gunprice = config.cvar('ggn_gunprice', 400, 'Set the price for the gun')
nadeprice = config.cvar('ggn_nadeprice', 300, 'Set the grenade price')
comboprice = config.cvar('ggn_comboprice', 600, 'Set the combo price (should set this little lower than the combined price, for a deal')
healthprice = config.cvar('ggn_healthprice', 6000, 'Set the health price (0 = off)')
config.text('\n')
config.text('* Advert/Announcement Configuration *')
ads = config.cvar('ggn_ads', 1, 'Advert/Announcement on?')
prefix = config.cvar('ggn_adsprefix', "[GGN - Guns'n'Grenades]", 'This comes before the actual advert/announcement')

config.write()
menu = 0
keypress = 0
weaponlist = 0

def load():
    global menu
    config.execute()
    es.ServerVar('ggn_ver', 'Version 1.5 ESP Beta').makepublic()
    menu = popuplib.easymenu('ggn_menu', '_popup_choice', ggn_men)
    menu.settitle("Guns'n'Grenades")
    menu.addoption('gun', 'Buy a Gun - $%s' % gunprice)
    menu.addoption('nade', 'Buy a Nade - $%s' % nadeprice)
    menu.addoption('both', 'Buy both - $%s' % comboprice)
    if healthprice > 0:
        menu.addoption('health', 'Buy Health - $%s' % healthprice)
    if not es.exists('saycommand', '!ggn'):
        es.regsaycmd('!ggn', 'ggn/send_menu')

def unload():
    menu.delete()

def send_menu():
    menu.send(es.getcmduserid())

def round_start(ev):
    if ads == 1:
        es.msg('#multi', "#green%s #defaultloaded, type !ggn to buy a gun, grenade, or both." % prefix)

def getWeaponList(userid):
    global weaponlist
    weaponlist = []
    player = playerlib.getPlayer(userid)
    for param in ('primary', 'secondary'):
      weapon = player.get(param)
      if weapon not in ('0', 0):
         weaponlist.append(weapon)
    if player.get('weaponindex', 'weapon_knife'):
      weaponlist.append('weapon_knife')
    for param, weapon in (('he', 'weapon_hegrenade'), ('fb', 'weapon_flashbang'), ('sg', 'weapon_smokegrenade'), ('c4', 'weapon_c4'), ('defuser', 'item_defuser')):
      count = player.get(param)
      if count not in ('0', 0):
         weaponlist.append(weapon)
    return weaponlist

def strip_player(userid):
    es.server.cmd('es_xfire %s player_weaponstrip kill' % userid)
    es.server.cmd('es_xgive %s player_weaponstrip' % userid)
    es.server.cmd('es_xfire %s player_weaponstrip strip' % userid)

def ggn_men(userid, choice, popupid):
    money = es.getplayerprop(userid, 'CCSPlayer.m_iAccount')
    getWeaponList(userid)
    old_weps = ' '.join(weaponlist)
    if choice == 'gun':
        if money >= gunprice:
            amoney = money - gunprice
            es.setplayerprop(userid, 'CCSPlayer.m_iAccount', amoney)
            strip_player(userid)
            es.delayed(.1, 'es_xgive %s weapon_%s' % (userid, gun))
        else:
            es.tell(userid, '#multi', "#green%s #defaultYou don't have enough cash for a gun. Your money: #lightgreen$#green%s#default, Gun costs #lightgreen$#green%s" % (prefix, money, gunprice))
    elif choice == 'nade':
        if money >= nadeprice:
            bmoney = money - nadeprice
            es.setplayerprop(userid, 'CCSPlayer.m_iAccount', bmoney)
            strip_player(userid)
            es.delayed(.1, 'es_xgive %s weapon_%s' % (userid, nade))
        else:
            es.tell(userid, '#multi', "#green%s #defaultYou don't have enough cash for a grenade. Your money: #lightgreen$#green%s#default, Grenade costs #lightgreen$#green%s" % (prefix, money, nadeprice))
    elif choice == 'both':
        if money >= comboprice:
            cmoney = money - comboprice
            es.setplayerprop(userid, 'CCSPlayer.m_iAccount', cmoney)
            strip_player(userid)
            es.delayed(.1, 'es_xgive %s weapon_%s;es_xgive %s weapon_%s' % (userid, gun, userid, nade))
        else:
            es.tell(userid, '#multi', "#green%s #defaultYou don't have enough cash for a gun and a grenade. Your money: #lightgreen$#green%s#default, Both cost #lightgreen$#green%s" % (prefix, money, comboprice))
    elif choice == 'health':
        if money >= healthprice:
            dmoney = money - healthprice
            es.setplayerprop(userid, 'CCSPlayer.m_iAccount', dmoney)
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 100)
        else:
            es.tell(userid, '#multi', "#green%s #defaultYou don't have enough cash for a health boost. Your money: #lightgreen$#green%s#default, Health costs #lightgreen$#green%s" % (prefix, money, healthprice))
    es.delayed(.1, 'es_xgive %s weapon_knife;es_xgive %s weapon_%s' % (userid, userid, old_weps))
